package com.small_it_office.flatserve.core.service;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.small_it_office.flatserve.core.ErrorResponder;

/**
 * HTTPT[rX\bhsɁAHTTPZbV݂Ȃ΂ȂȂƂ܂B
 * <p>
 * ̃Ame[VHTTPT[rX\bhɕt^ꍇA\bhsO
 * HTTPZbVLǂmFALHTTPZbV݂Ȃꍇɂ
 * HTTPT[rX\bh͎sAZbV^CAEgƂăG[s܂B
 * </p>
 * <p>
 * G[@͈ȉ̂ꂩƂȂ܂B@w肳Ăꍇ́Aȉ̔ԍ̒ႢقD悳܂B
 * </p>
 * <ol>
 * <li>{@link errorResponder()}w肳Ă΁Aw肳ꂽ{@link ErrorResponder}̃CX^X𐶐ĎsAԂ܂B</li>
 * <li>{@link forwardPath()}w肳ꂽꍇAw肳ꂽpXɃNGXgtH[h܂B</li>
 * <li>{@link com.small_it_office.flatserve.core.config.Config}IuWFNgɎw肳ꂽ{@link ErrorResponder}sAԂ܂B</li>
 * <li>{@link com.small_it_office.flatserve.core.config.Config}IuWFNgɎw肳ꂽpXɃNGXgtH[h܂B</li>
 * <li>Lw肳ĂȂꍇ́AȒPȃeLXg̃G[bZ[WԂ܂B</li>
 * </ol>
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD, ElementType.ANNOTATION_TYPE})
public @interface SessionRequired {

	/**
	 * ZbV^CAEgG[̏ꍇɃG[stH[h̃pXB
	 */
	String forwardPath() default "";

	/**
	 * ZbV^CAEgG[̏ꍇɃG[sNXB
	 */
	Class<? extends ErrorResponder> errorResponder() default ErrorResponder.class;

}
